poj 2288 Islands and Bridges (用DP解汉密尔顿问题)

59 篇文章 0 订阅
Islands and Bridges
Time Limit: 4000MS Memory Limit: 65536K
Total Submissions: 7970 Accepted: 2055

Description

Given a map of islands and bridges that connect these islands, a Hamilton path, as we all know, is a path along the bridges such that it visits each island exactly once. On our map, there is also a positive integer value associated with each island. We call a Hamilton path the best triangular Hamilton path if it maximizes the value described below. 

Suppose there are n islands. The value of a Hamilton path C1C2...Cn is calculated as the sum of three parts. Let Vi be the value for the island Ci. As the first part, we sum over all the Vi values for each island in the path. For the second part, for each edge CiC i+1 in the path, we add the product Vi*V i+1. And for the third part, whenever three consecutive islands CiC i+1C i+2 in the path forms a triangle in the map, i.e. there is a bridge between Ci and C i+2, we add the product Vi*V i+1*V i+2

Most likely but not necessarily, the best triangular Hamilton path you are going to find contains many triangles. It is quite possible that there might be more than one best triangular Hamilton paths; your second task is to find the number of such paths. 

Input

The input file starts with a number q (q<=20) on the first line, which is the number of test cases. Each test case starts with a line with two integers n and m, which are the number of islands and the number of bridges in the map, respectively. The next line contains n positive integers, the i-th number being the Vi value of island i. Each value is no more than 100. The following m lines are in the form x y, which indicates there is a (two way) bridge between island x and island y. Islands are numbered from 1 to n. You may assume there will be no more than 13 islands. 

Output

For each test case, output a line with two numbers, separated by a space. The first number is the maximum value of a best triangular Hamilton path; the second number should be the number of different best triangular Hamilton paths. If the test case does not contain a Hamilton path, the output must be `0 0'. 

Note: A path may be written down in the reversed order. We still think it is the same path.

Sample Input

2
3 3
2 2 2
1 2
2 3
3 1
4 6
1 2 3 4
1 2
1 3
1 4
2 3
2 4
3 4

Sample Output

22 3
69 1

Source


题意:

求一条哈密顿回路,但是权值计算不同,包括三部分:

1.经过个所有点的权值相加。

2.经过的连续两个点的权值的乘积。

3,能够构成三角型的连续三个点的乘积。

这些全部加起来就是这条回路的总权值。输出最大权值和这个最大权值的路线有多少条。


思路:

三维DP:

第一维:二进制状态压缩存访问的岛屿的情况。

第二维:存上一个点访问的岛屿标号。

第三维:存上上个点访问的岛屿标号。


注意:

要考虑只有一个岛屿的情况。还有一条汉密尔顿路径在无向图中实际上为两条,但题目只算作一条。


代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
#define maxn 13
#define maxx 1<<13
using namespace std;

typedef long long ll;
int n,m;
bool vis[maxn][maxn];
ll ans,cnt;
ll dp[maxx][maxn][maxn];   // 状态、上一次访问的岛屿、上上次
ll num[maxx][maxn][maxn];
ll val[maxn];
vector<int>edge[maxn];

void init()
{
    int i,j,u,v,s,s1,s2;
    memset(dp,-1,sizeof(dp));
    memset(num,0,sizeof(num));
    memset(vis,0,sizeof(vis));
    for(i=0; i<n; i++)
    {
        edge[i].clear();
    }
    for(i=1; i<=m; i++)
    {
        scanf("%d%d",&u,&v);
        u--,v--;
        vis[u][v]=vis[v][u]=1;
        edge[u].push_back(v);
        edge[v].push_back(u);
        s1=1<<u;
        s2=1<<v;
        s=0|s1|s2;
        dp[s][u][v]=dp[s][v][u]=val[u]+val[v]+val[u]*val[v];
        num[s][u][v]=num[s][v][u]=1;
    }
}
void solve()
{
    int i,j,k,p,r,s,sz,ss,v;
    ll nv,nnum,tv;
    r=1<<n;
    for(k=0; k<r; k++)    // 对状态循环
    {
        s=k;
        for(i=0; i<n; i++)  // 对上一次循环
        {
            if(s&(1<<i))    // 如果s能把i当做上次
            {
                for(j=0; j<n; j++)  // 对上上循环
                {
                    if(i==j||!(s&(1<<j))||dp[s][i][j]==-1) continue ;
                    sz=edge[i].size();
                    for(p=0; p<sz; p++)
                    {
                        v=edge[i][p];
                        if(s&(1<<v)) continue ;
                        nv=dp[s][i][j];
                        nnum=num[s][i][j];
                        tv=nv+val[v]+val[i]*val[v];
                        if(vis[j][v]) tv+=val[j]*val[i]*val[v];
                        ss=s|(1<<v);
                        if(dp[ss][v][i]<tv)        // 没出现则更新
                        {
                            dp[ss][v][i]=tv;
                            num[ss][v][i]=nnum;
                        }
                        else if(dp[ss][v][i]==tv)  // 出现累加num
                        {
                            num[ss][v][i]+=nnum;
                        }
                    }
                }
            }
        }
    }
}
int main()
{
    int i,j,t,s;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d",&n,&m);
        for(i=0; i<n; i++)
        {
            scanf("%I64d",&val[i]);
        }
        init();
        if(n==1)
        {
            printf("%I64d 1\n",val[0]);
            continue ;
        }
        solve();
        ans=-1;
        s=(1<<n)-1;
        for(i=0; i<n; i++)
        {
            for(j=0; j<n; j++)
            {
                if(ans<dp[s][i][j]) ans=dp[s][i][j];
            }
        }
        if(ans==-1)
        {
            printf("0 0\n");
            continue ;
        }
        cnt=0;
        for(i=0; i<n; i++)
        {
            for(j=0; j<n; j++)
            {
                if(ans==dp[s][i][j]) cnt+=num[s][i][j];
            }
        }
        printf("%I64d %I64d\n",ans,cnt/2);
    }
    return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值